function nat_freqs=find_freq_timo_TP(newnewddd,bracket,tol)
% Given a span of frequencies known to contain the natural frequency, use the bisection method to locate it within tolerance tol. % Note: bisection finds a root or a singularity.
global b len E rho x_section G nu;
ddd=newnewddd;
jmax=40; % Maximum allowed number of bisections
nat_freqs=[];
[rows]=size(bracket);
if(rows==0)
error('No frequencies bracketed?');
end;
for k=1:rows
w_low=bracket(k,1); %load the lower frequencies at the brackets found
w_high=bracket(k,2); %load the higher frequencies at the brackets found
%ymid is the receptance at the brackets with higher freuencies
ymid=beam_recept_timoshenko(w_high,E,rho,b,ddd,len,x_section,G,nu);
%y is the receptance at the brackets with lower frequencies
y=beam_recept_timoshenko(w_low,E,rho,b,ddd,len,x_section,G,nu);
%if the signs of the above two receptances are same, then error
if(y.*ymid>=0)
error('Roots must be bracketed for find_freq to work.');
end;
%if the receptance at the brackets with lower frequencies is negative,
%then store the lower frequency in "estimate". on the other hand, if
%the receptance at the brackets with lower frequencies is positive or
%zero, then store the higher frequency in "estimate".
if(y<0)
estimate=w_low;
dw=w_high-w_low; %delta frequency
else
estimate=w_high;
dw=w_low-w_high; %delta frequency
end;
for j=1:jmax
dw=dw.*0.5;
%here "wmid" is the frequency in the middle of the lower frequency
%and the higher frequency
wmid=estimate+dw;
%the receptance at the freuency of "wmid" can be found by sending
%the frequency "wmid" to the "beam_recept_timoshenko" again.
ymid=beam_recept_timoshenko(wmid,E,rho,b,ddd,len,x_section,G,nu);
%if the receptance at the frequency of "wmid" is equal or smaller
%than zero, then the frequency of "wmid" can be stored into
%"estimate" insted of "w_low"
if(ymid<=0);
estimate=wmid;
end;
%if the magnitude of "dw" is smaller than the tolerance set in the
%main function, then the frequency in "estimate" is recorded and
%stored
if(abs(dw)<tol)
nat_freqs(k)=estimate;
end;
if(ymid==0)
nat_freqs(k)=estimate;
end;
end;
end;
nat_freqs=nat_freqs';