%Function main.m
%This is the main file of the program, and it will call other files
%Written in 18/09/09 by Zhao Mingming
%This program is a modified code from Dr.Rodney Entwistle
%clear all;


%Give parameter values
% w = frequency rad/s
% E = Elastic Modulus Pa
% rho = density kg/m^3
% b = width (or diameter) of beam segments in sequence
% d = depth (or diameter) of beam segments in sequence
% len = length of beam segments in sequence
% shape = 'rectangular' or 'circular' cross-section
%-------------------------------------------------------------------------------------------------------------
frequency_required=[selected_frequency;4;9.8];

rho=2790;%densite
%E=72500e6;%young
E=73000e6;%young AU4G1
%G=27200e6;%coulomb
G=27400e6;%coulomb AU4G1
nu=(E/(2*G))-1;
width=0.04;%bars width

%a1=6; a2=0.3; a3=0.003;
a1=6; a2=0.3; a3=0.003;
coeffs=[a1;a2;a3];
tol=[0.01;0.1;0.1];
number_fn=3; shape='rectangular';
profile='cubic';
analysis='timoshenko';
if strcmp(analysis,'timoshenko')
    method='Method_Timoshenko';
    method_NN='Method_Timoshenko_NN';
elseif strcmp(analysis,'euler')
    method='Method_Euler';
    method_NN='Method_Timoshenko_NN';
    Euler_NN='method_Euler_NN';
else
    error('Unknown analysis method');
end;
x_section='rectangular';
number_of_elements=300;
ploton=false;
%-------------------------------------------------------------------------------------------------------------
delta_a=1.000001; df=1.1.*tol;
while any(abs(df)>tol)
    %displys the resulted natural frequencies
    frequency_old=eval([method ' (profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton)']);
    slope=[];
    %for the first three natural frequencies
    for k=1:3
        coeffs_new=coeffs;
        coeffs_new(k)=coeffs_new(k).*delta_a;
        frequency_new=eval([method '(profile,coeffs_new,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton)']);
        
        disp(['f0: ' num2str(frequency_new(1)) '  f1/f0: ' num2str(frequency_new(2)) '  f2/f0: ' num2str(frequency_new(3))])
        
        slope=[slope (frequency_new-frequency_old)./(coeffs_new(k)-coeffs(k))];
    end;
    df=frequency_required-frequency_old;
    da=(slope)\df;
    coeffs=coeffs+da;
   

%Get the correct coefficients and check natural frequencies
coeffs=coeffs-da;
Natural_Frequencies_timo=eval([method '(profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton)']);
disp(['---------------------->Success'])



%%Calculate the positions of the bearing points
%Hole_Positions=Drilled_Hole_Predictions(E,rho,b,d,len,shape)
%%Determine the G-code so that other CNC machines could cut this marimba bar directly
%G_Code_Generation(d, len, bar_length);
%%-------------------------------------------------------------------------------------------------------------
%%Call the fine tuning program (correct the uncertainties of the tested material)
%Tuning_Program(method,method_NN,profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton,d)
%%-------------------------------------------------------------------------------------------------------------
%%Re-predict the shape geometry based on the predicted and measured frequencies
%Shape_Reprediction(method,method_NN,profile,coeffs,E,G,rho,x_section,nu,d0,width,bar_length,number_of_elements,tol,number_fn,ploton,d)